/*
btseek.c Version 0.1.0  Btree change position in database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

DWORD btseek(btreefmt *bthdr, long ofst)
   {
   DWORD  msgerr;
   LPVOID lpMsgBuf;
   DWORD loc;
   bthdr->reason = 0;
   loc = SetFilePointer(bthdr->hndl,ofst,
      NULL,FILE_BEGIN);
   if (loc == UINT_MAX)
      {
      msgerr = GetLastError();
      bthdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,             /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,                /* message length */
         NULL);            /* insertion values */
      fprintf(stderr,"btseek: %s", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"btseek: %s\n",
         bthdr->dbname);
      fprintf(stderr,"btseek: ofst error "
	 "(hndl %d ofst %08x)\n",
	 bthdr->hndl, ofst);
      bthdr->ofst = (long) loc;
      return(loc);
      } /* SetFilePointer err */
   else if (loc != (DWORD) ofst)
      {
      fprintf(stderr,"btseek: error "
	 "(hndl %d ofst %08x loc %08x)\n",
	 bthdr->hndl, ofst, loc);
      bthdr->reason = BTREE_ERR + 501;
      bthdr->ofst = (long) loc;
      return(UINT_MAX);
      } /* SetFilePointer err */
   bthdr->ofst = (long) loc;
   return(loc);
   } /* btseek */
